<?php

//DBクラスの読み込み　&　各種設定を読み込み
require_once("DB.php");

//-----------------------------
//ページング機能
//引数 : ナビゲーションバーに何ページ分表示するか(max_page)、左端のページ数、右端のページ数、１ページに何行表示するか？(num_list),全データ数(num_all),何ページ目か？(now_page), リンク先URL
//戻り値 : ナビゲーションバーの表示
//(説明）リンク先URLは、 "./test.php?page_number="　のように記載。最後にこの関数でページ数を付け足す。
function paging($max_page,$left_page,$right_page,$num_list,$num_all,$now_page,$url)
{

	$all_page = ceil($num_all / $num_list); //全ページ数を取得

	if($now_page == ""){$now_page = 1;}
	if($max_page == ""){$max_page = 10;} //デフォルトでは、ページングで全部で１0ページ表示
	if($left_page == ""){$left_page = 1; }//左端のページ数
	if($right_page == "" and $all_page <= $max_page){ //右端のページ数
		$right_page = $all_page;
	}elseif($right_page == "" and $all_page >= $max_page){
		$right_page = $max_page;
	}

	echo "【".$all_page."ページ中 <font color='red'>".$now_page."</font>ページ目表示】　";

    if($left_page != 1){ //左端のページが１以外ならジャンプ用のリンク表示  （最初のページ）<<<  , （前の".$max_page."ページ）<< , （前のページ）<

   	  if(($left_page - $max_page) >= 2){
      	//最初のページへジャンプの時
      	$tpage = 1;
      	$tlpage = 1;
      	$trpage = $max_page;

      	echo "<a href='".$url.$tpage."&lpage=".$tlpage."&rpage=".$trpage."'>&lt;&lt;&lt;</a>　";
   	  }

   	  if($left_page > 2){
      	//前のMax_page分ジャンプの時
      	if(($now_page - $max_page) <= 1){ $tpage =1; }else{$tpage = $now_page - $max_page;}
      	if(($left_page-$max_page) <= 1){ $tlpage = 1; }else{$tlpage = $left_page - $max_page;}
      	$trpage = $tlpage + $max_page -1;

      	echo "<a href='".$url.$tpage."&lpage=".$tlpage."&rpage=".$trpage."'>&lt;&lt;</a>　";
   	  }
      	//前のページのとき
       	$tpage =$now_page-1;
      	$tlpage = $left_page -1;
      	$trpage = $tlpage + $max_page -1;

      	echo "<a href='".$url.$tpage."&lpage=".$tlpage."&rpage=".$trpage."'>&lt;  </a>";
    }

    for($i=$left_page;$i<=$right_page;$i++){
    		if($i != $now_page){
				echo "<a href='".$url.$i."&lpage=".$left_page."&rpage=".$right_page."'>".$i."</a>　";
			}else{
				echo "<font color='red'>".$i."</font>　";
			}

    }

    if($right_page < $all_page){ //右端のページが最大のページ数より小さかったらならジャンプ用のリンク表示  （最初のページ）<<<  , （前の".$max_page."ページ）<< , （前のページ）<

    	//次のページのとき
       	$tpage =$now_page+1;
      	$trpage = $right_page + 1;
      	$tlpage = $trpage - $max_page +1;

      	echo "<a href='".$url.$tpage."&lpage=".$tlpage."&rpage=".$trpage."'> &gt;</a>　";

      if(($right_page + 2) <= $all_page){
      	//次のMax_page分ジャンプの時
      	if(($now_page + $max_page) >= $all_page){ $tpage =$all_page; }else{$tpage = $now_page + $max_page;}
      	if(($right_page+$max_page) >= $all_page){ $trpage = $all_page; }else{$trpage = $right_page + $max_page;}
      	$tlpage = $trpage - $max_page +1;

      	echo "<a href='".$url.$tpage."&lpage=".$tlpage."&rpage=".$trpage."'> &gt;&gt;</a>　";
      }

      if(($right_page + $max_page) < $all_page){
      	//最後のページへジャンプの時
      	$tpage = $all_page;
      	$trpage = $all_page;
      	$tlpage = $trpage - $max_page +1;

      	echo "<a href='".$url.$tpage."&lpage=".$tlpage."&rpage=".$trpage."'>&gt;&gt;&gt;</a>";

      }

    }



	return;

}

//-------------------magic_quotes_gpc = On　にしたら <script>alert("hello!");</script> も実行されなくなったし、',",とかもエスケープしてるようなのでこの関数は使わない----------
//クロスサイトスクリプティング対策
//引数 : 変換したいデータ（配列でもOK)
//戻り値 : 変換したデータ

function rhe($data, $charset='UTF-8', $quote_style=ENT_QUOTES)
{
	//配列だったら
	if (is_array($data)) {
		foreach ($data as $key => $val) {
			//keyがエスケープされた場合、重複するため一旦データを削除
			unset($data[$key]);
			//文字列の文字コードを同じ文字コードへ変換し、有効ではない文字を取り除く
			$key = mb_convert_encoding($key, $charset, $charset);
			//エンティティ化
			$key = htmlentities($key, $quote_style, $charset);
			if (is_array($val)) {
				//値が配列の場合、再帰的に配列を処理
				$val = rhe($val, $charset, $quote_style);
			} else {
				//文字列の文字コードを同じ文字コードへ変換し、有効ではない文字を取り除く
				$val = mb_convert_encoding($val, $charset, $charset);
				//エンティティ化
				$val = htmlentities($val, $quote_style, $charset);
			}
			//値を再設定
			$data[$key] = $val;
		}
		//エンティティ化した配列を返す
		return $data;
	} else {
		//文字列の文字コードを同じ文字コードへ変換し、有効ではない文字を取り除く
		$data = mb_convert_encoding($data, $charset, $charset);
		//エンティティ化して返す
	    return htmlentities($data, $quote_style, $charset);
	}
}

//------------------------------------------------------------------------------
//データベースオープン関数
//引数 : なし
//戻り値 : データベースハンドル
function db_open()
{
	require("./teigi.php");

    $dsn = "$dbtype://$user:$pass@$sv/$dbname";

    $conn = DB::connect($dsn);
    if(DB::isError($conn)){
      system_error("DBへの接続に失敗しました");
    }

	return $conn;
}

//------------------------------------------------------------------------------
//SQL実行関数
//引数 : データベースハンドル、SQL文
//戻り値：実行結果
function do_sql($conn,$sql)
{
    //SQL実行
    $res = $conn->query($sql);
    if(DB::isError($res)){
      system_error("SQLの実行に失敗しました");
    }

	return $res;
}

//------------------------------------------------------------------------------
//SQL実行関数
//引数 : データベースハンドル
//戻り値：なし
function db_close($conn)
{
	$conn->disconnect();

	return ;
}

//------------------------------------------------------------------------------
//DBオープン、SQL実行、DBクローズ
//引数 : SQL文
//戻り値：実行結果
function db_open_exec_close($sql)
{
	require("./teigi.php");

    $dsn = "$dbtype://$user:$pass@$sv/$dbname";

    $conn = DB::connect($dsn);
    if(DB::isError($conn)){

      system_error("DBへの接続に失敗しました");
    }

    $res = $conn->query($sql);
    if(DB::isError($res)){
      system_error("SQLの実行に失敗しました ");
    }

	$conn->disconnect();

	return $res;
}

//------------------------------------------------------------------------------
//DBオープン、SQL実行、DBクローズ
//引数 : SQL文
//戻り値：SQL実行後に取得したID
function db_open_exec_getid_close($sql)
{
	require("./teigi.php");

    $dsn = "$dbtype://$user:$pass@$sv/$dbname";

    $conn = DB::connect($dsn);
    if(DB::isError($conn)){

      system_error("DBへの接続に失敗しました");
    }

    $res = $conn->query($sql);
    if(DB::isError($res)){
      system_error("SQLの実行に失敗しました ");
    }

	$id = mysql_insert_id();

	$conn->disconnect();

	return $id;
}


//---------------------これ後で作る--------------------------------------------------------
//DBオープン、SQL実行、DBクローズ
//引数 : SQL文,フィールド数、タイプ（０：結果が１つのみ、１：複数の結果がある）
//戻り値：実行結果を配列に格納、エラー

function db_open_exec_close_process($sql,$num,$type)
{
	require("./teigi.php");

    $dsn = "$dbtype://$user:$pass@$sv/$dbname";

    $conn = DB::connect($dsn);
    if(DB::isError($conn)){

      system_error("DBへの接続に失敗しました");
    }

    $res = $conn->query($sql);
    if(DB::isError($res)){
      system_error("SQLの実行に失敗しました ");
    }

	$conn->disconnect();

	if($type == 1){}



	return $res;
}

//------------------------------------------------------------------------------
//日時を表示させる（ただの表示のみ）
//引数 : type, nichiji
//戻り値：表示のみ
//  type : 0: 年月日時分表示
//  nichiji :　その日時を表示、未記入なら現在の時間
function view_date($type,$nichiji){

  if($nichiji != ""){
  	list($dum1,$dum2) = split(' ',$nichiji);
	list($set_year,$set_month,$set_day) = split('-', $dum1);
	list($set_hour,$set_minute,$dum3) = split(':',$dum2);
  }else{
   $set_year = date("Y");
   $set_month = date("m");
   $set_day = date("d");
   $set_hour = date("H");
   $set_minute = date("i");
  }

  if($type== 0){
    echo $set_year."年 ".$set_month."月 ".$set_day."日 ".$set_hour."時 ".$set_minute."分";
  }elseif($type==1){
  	echo $set_year."年".$set_month."月".$set_day."日";
  }

}


//------------------------------------------------------------------------------
//日時を表示させる（フォーム形式）
//引数 : minus, plus, type, nichiji、(これ以降、name属性の名前）year,month,day,hour,minute
//戻り値：表示のみ
//　minus : 現在から何年引くか
//  plus : 現在から何年足すか
//  type : 0: 入力可能、1: 検索の時に使う（現在の日時は使わない　デフォルトはブランクにする）,2:検索時に使う（年月日のみ、デフォルトはブランクにする）
//  nichiji :　その日時を表示、未記入なら現在の時間
function disp_date($minus,$plus,$type,$nichiji,$year,$month,$day,$hour,$minute){

  if($nichiji != ""){
  	list($dum1,$dum2) = split(' ',$nichiji);
	list($set_year,$set_month,$set_day) = split('-', $dum1);
	list($set_hour,$set_minute,$dum3) = split(':',$dum2);
  }else{
   $set_year = date("Y");
   $set_month = date("m");
   $set_day = date("d");
   $set_hour = date("H");
   $set_minute = date("i");
  }

//現在の日時をデフォルト設定にする場合
   if($type == 0){
     // 年の表示
      echo "<select name='".$year."'>";
	  for ($i = $set_year - $minus ; $i <= $set_year + $plus ; $i ++){
	    if($i != $set_year){
		  echo "<option value='".$i."'>".$i."</option>";
		}else{
		  echo "<option value='".$i."' selected>".$i."</option>";
		}
	  }
	  echo "</select>";
	  echo "年 ";

	 //月の表示
	  echo "<select name='".$month."'>";
	  for ($i = 1 ; $i <= 12 ; $i ++){
	  	$dum = sprintf("%02d",$i);
	    if($i != $set_month){
		  echo "<option value='".$dum."'>".$dum."</option>";
		}else{
		  echo "<option value='".$dum."' selected>".$dum."</option>";
		}
	  }
	  echo "</select>";
	  echo "月 ";

	 //日の表示
	  echo "<select name='".$day."'>";
	  for ($i = 1 ; $i <= 31 ; $i ++){
	  	$dum = sprintf("%02d",$i);
	    if($i != $set_day){
		  echo "<option value='".$dum."'>".$dum."</option>";
		}else{
		  echo "<option value='".$dum."' selected>".$dum."</option>";
		}
	  }
	  echo "</select>";
	  echo "日 ";

	 //時の表示
	  echo "<select name='".$hour."'>";
	  for ($i = 0 ; $i <= 23 ; $i ++){
	  	$dum = sprintf("%02d",$i);
	    if($i != $set_hour){
		  echo "<option value='".$dum."'>".$dum."</option>";
		}else{
		  echo "<option value='".$dum."' selected>".$dum."</option>";
		}
	  }
	  echo "</select>";
	  echo "時 ";

	 //分の表示
	  echo "<select name='".$minute."'>";
	  for ($i = 0 ; $i <= 59 ; $i ++){
	  	$dum = sprintf("%02d",$i);
	    if($i != $set_minute){
		  echo "<option value='".$dum."'>".$dum."</option>";
		}else{
		  echo "<option value='".$dum."' selected>".$dum."</option>";
		}
	  }
	  echo "</select>";
	  echo "分 ";

//ブランクをデフォルト設定にする場合 （年月日時分表示）
   }elseif($type == 1){
      echo "<select name='".$year."'>";
	  echo "<option value='' selected></option>";
	  for ($i = $set_year - $minus ; $i <= $set_year + $plus ; $i ++){
		  echo "<option value='".$i."'>".$i."</option>";
	  }
	  echo "</select>";
	  echo "年 ";

	 //月の表示
	  echo "<select name='".$month."'>";
	  echo "<option value='' selected></option>";
	  for ($i = 1 ; $i <= 12 ; $i ++){
	  	$dum = sprintf("%02d",$i);
		echo "<option value='".$dum."'>".$dum."</option>";
	  }
	  echo "</select>";
	  echo "月 ";

	 //日の表示
	  echo "<select name='".$day."'>";
	  echo "<option value='' selected></option>";
	  for ($i = 1 ; $i <= 31 ; $i ++){
	  	$dum = sprintf("%02d",$i);
		echo "<option value='".$dum."'>".$dum."</option>";
	  }
	  echo "</select>";
	  echo "日 ";

	 //時の表示
	  echo "<select name='".$hour."'>";
	  echo "<option value='' selected></option>";
	  for ($i = 0 ; $i <= 23 ; $i ++){
	  	$dum = sprintf("%02d",$i);
		echo "<option value='".$dum."'>".$dum."</option>";
	  }
	  echo "</select>";
	  echo "時 ";

	 //分の表示
	  echo "<select name='".$minute."'>";
	  echo "<option value='' selected></option>";
	  for ($i = 0 ; $i <= 59 ; $i ++){
	  	$dum = sprintf("%02d",$i);
		echo "<option value='".$dum."'>".$dum."</option>";
	  }
	  echo "</select>";
	  echo "分 ";
//ブランクをデフォルト設定にする場合 （年月日表示）
   }elseif($type == 2){
      echo "<select name='".$year."'>";
	  echo "<option value='' selected></option>";
	  for ($i = $set_year - $minus ; $i <= $set_year + $plus ; $i ++){
		  echo "<option value='".$i."'>".$i."</option>";
	  }
	  echo "</select>";
	  echo "年 ";

	 //月の表示
	  echo "<select name='".$month."'>";
	  echo "<option value='' selected></option>";
	  for ($i = 1 ; $i <= 12 ; $i ++){
	  	$dum = sprintf("%02d",$i);
		echo "<option value='".$dum."'>".$dum."</option>";
	  }
	  echo "</select>";
	  echo "月 ";

	 //日の表示
	  echo "<select name='".$day."'>";
	  echo "<option value='' selected></option>";
	  for ($i = 1 ; $i <= 31 ; $i ++){
	  	$dum = sprintf("%02d",$i);
		echo "<option value='".$dum."'>".$dum."</option>";
	  }
	  echo "</select>";
	  echo "日 ";
   }

}



//------------------------------------------------------------------------------
//メールアドレスが正しい記述か確認
//引数 : メールアドレス
//戻り値：結果　1: true 0:false
function mail_check($mailaddress){

//	if (preg_match('/^[a-zA-Z0-9_\.\-]+@[A-Za-z0-9]+\.[A-Za-z0-9]+$/',$mailaddress)){
if (preg_match("/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/",$mailaddress)){
		return 1;
	}else{
		return 0;
	}
}


//------------------------------------------------------------------------------
//SQLインジェクション対策
//引数 : POST or GET 等で得た変数
//戻り値 : SQLインジェクション対策済みの変数
function sql_inj($err_code)
{
print("エラー発生 : " . $err_code);
die;
}



//------------------------------------------------------------------------------
//システムエラー発生時の処理
//引数 : エラーコード
//戻り値 : なし
function system_error($err_code)
{
print("エラー発生 : " . $err_code);
die;
}

?>